#!/usr/bin/perl

##########
#
#  Bandley3's Counter v1.0
#  UNIX tested - Apache-Mac, Apache-PC
#  Copyright 2002 Bandley3.com
#  http://bandley3.com
#  cfs@mac.com
#
##########
#
#  Licensing Agreement
#
#  Purchasing a license and/or installing this script constitutes
#  acceptance of the licensing agreement you read before purchasing
#  said license. This agreement can be found at Bandley3.com.
#  Bandley3's Counter v1.0 is licensed, not sold.
#
#
##########

# set to the number of IPs you'd like to check.
# the larger the number, the slower the script.
# Zero will disable IP checking.
$IPCHECK="0";

# the following IMAGES variable has 3 possible responses.
# no - means text only.
# standard - means 2 end graphics with number graphics in middle.
# deluxe - means background graphic with number graphics centered.
# (deluxe setting needs HEIGHT/WIDTH/STACK/VALIGN/HALIGN below).
$IMAGES="standard";

# full URL to STANDARD graphics directory (no trailing slash).
$SIMGPATH="http://yourdomain.com/images/counter/standard";

# full URL to DELUXE graphics directory (no trailing slash).
$DIMGPATH="http://yourdomain.com/images/counter/deluxe";


##### next 5 variables are for deluxe only #####

# set to exact size of background image.
$WIDTH="140";
$HEIGHT="140";

# set to yes to stack number images. no to leave horizontal.
$STACK="no";

# set to left, right, or center to align number images.
$ALIGN="right";

# set to top, middle, or bottom to vertically align number images.
$VALIGN="bottom";





#################### no editing necessary below this line


open(DATA, "<b3cdata/count.txt") || &error("can't open file, try chmod 777 of data directory or txt files.");
flock(DATA, 2);
@data=<DATA>;
flock(DATA, 8);
close(DATA);

open(DATAP, "<b3cdata/countIP.txt") || &error("can't open file, try chmod 777 of data directory or txt files.");
@datap=split(/\r/, <DATAP>);
close(DATAP);

$dnum=$#datap + 1;

while ($IPCHECK < $dnum) {
$dnum--;
shift(@datap);
}


#clear ip

$clear="0";

if (!$ENV{'REMOTE_ADDR'}) {
$stip="none";
}
else {
$stip=$ENV{'REMOTE_ADDR'};
}

if ($ENV{'HTTP_USER_AGENT'} =~ m/AOL/) {

$stip4=$stip;
$stip4 =~ s/\.\d+$//;

foreach $datap(@datap) {

$datap4=$datap;
$datap4 =~ s/\.\d+$//;

if ($stip4 eq $datap4) {
$clear="1";
}
}

}

else {

$stip2=$stip;
$stip2 =~ s/\.\d+$//;

foreach $datap(@datap) {

$datap2=$datap;
$datap2 =~ s/\.\d+$//;

if ($stip2 eq $datap2) {
$clear="1";
}
}

}




if ($clear eq "0") {
$newtot=$data[0] + 1;
open(DATA, ">b3cdata/count.txt") || &error("can't open file, try chmod 777 of data directory or txt files.");
flock(DATA, 2);
print DATA "$newtot";
flock(DATA, 8);
close(DATA);


if ($dnum < $IPCHECK) {
open(DATAP, ">>b3cdata/countIP.txt") || &error("can't open file, try chmod 777 of data directory or txt files.");
flock(DATAP, 2);
print DATAP "$stip\r";
flock(DATAP, 8);
close(DATAP);

}
else {

shift(@datap);

open(DATAP, ">b3cdata/countIP.txt") || &error("can't open file, try chmod 777 of data directory or txt files.");
flock(DATAP, 2);
foreach $da(@datap) {
print DATAP "$da\r";
}
print DATAP "$stip\r";
flock(DATAP, 8);
close(DATAP);
}


}
else {
$newtot=$data[0];
}


if (lc($IMAGES) eq "no") {
print "Content-type:text/html\n\n";
print "$newtot";
exit;
}
elsif (lc($IMAGES) eq "standard") {
print "Content-type:text/html\n\n";

@newt=split(//, $newtot);
$hnewt=$#newt + 1;

print <<"HTML";
<table cellpadding=0 cellspacing=0 border=0>
<tr>
<td nowrap><img src=$SIMGPATH/left.gif border=0></td>
<td nowrap>
HTML

$nin="-1";
foreach $newt(@newt) {
$nin++;
print "<img src=$SIMGPATH/$newt[$nin].gif border=0>";
}

print <<"HTML";
</td>
<td nowrap><img src=$SIMGPATH/right.gif border=0></td>
</tr>
</table>
HTML

}
elsif (lc($IMAGES) eq "deluxe") {
print "Content-type:text/html\n\n";

@newt=split(//, $newtot);
$hnewt=$#newt + 1;

print <<"HTML";
<table height=$HEIGHT width=$WIDTH cellpadding=0 cellspacing=0 border=0>
<tr><td height=100% width=100% background=$DIMGPATH/bg.gif valign=$VALIGN align=$ALIGN>
HTML

$nin="-1";
foreach $newt(@newt) {
$nin++;
if (lc($STACK) eq "yes") {
print "<img src=$DIMGPATH/$newt[$nin].gif border=0><br>";
}
else {
print "<img src=$DIMGPATH/$newt[$nin].gif border=0>";
}
}

print <<"HTML";
</td></tr></table>
HTML

}

########## error

sub error {
print "Content-type:text/html\n\n";
print "Error<br><br>$_[0]";
exit;
}